(function(){
var _verbose = false;

var c2Runtime;

var step = -1;
var started = false;
var audioBuffer = [];
var timerUpdate;


var listOfAllSong = ["321_1.ogg","321_2.ogg","321_3.ogg","321_fight.ogg","bonus_2xtune.ogg","bonus_block.ogg","bonus_shock.ogg","bonus_slowtime.ogg","butt_level.ogg","butt_menu.ogg","coin.ogg","enemy_fall_1.ogg","enemy_fall_2.ogg","enemy_fall_3.ogg","enemy_fall_4.ogg","enemy_fly_1.ogg","enemy_fly_10.ogg","enemy_fly_2.ogg","enemy_fly_3.ogg","enemy_fly_4.ogg","enemy_fly_5.ogg","enemy_fly_6.ogg","enemy_fly_7.ogg","enemy_fly_8.ogg","enemy_fly_9.ogg","fight_enemy_hit1.ogg","fight_enemy_hit2.ogg","fight_enemy_hit3.ogg","fight_enemy_hit4.ogg","fight_enemy_hit5.ogg","fight_enemy_hit6.ogg","fight_the_boss_1.ogg","fight_the_boss_2.ogg","gameover_defeat.ogg","gameover_victory.ogg","jackpot.ogg","module_0.ogg","module_1.ogg","module_2.ogg","module_3.ogg","module_4.ogg","module_5.ogg","module_6.ogg","module_7.ogg","module_8.ogg","module_9.ogg","music_ingame.ogg","music_menu.ogg","music_menu_start.ogg","newrecord.ogg","phoenix.ogg","player_death.ogg","revivalepicburstinyourface.ogg","splash_phase_1.ogg","splash_phase_2.ogg","splash_phase_3.ogg","victory_coin.ogg","victory_full_coin.ogg","victory_star.ogg","weapon_hit_0.ogg","weapon_hit_1.ogg","weapon_hit_10_0.ogg","weapon_hit_10_1.ogg","weapon_hit_10_2.ogg","weapon_hit_11.ogg","weapon_hit_12.ogg","weapon_hit_13.ogg","weapon_hit_14.ogg","weapon_hit_15.ogg","weapon_hit_16.ogg","weapon_hit_17.ogg","weapon_hit_18.ogg","weapon_hit_19.ogg","weapon_hit_2.ogg","weapon_hit_20.ogg","weapon_hit_21_0.ogg","weapon_hit_21_1.ogg","weapon_hit_21_2.ogg","weapon_hit_21_3.ogg","weapon_hit_21_4.ogg","weapon_hit_21_5.ogg","weapon_hit_21_6.ogg","weapon_hit_21_7.ogg","weapon_hit_21_8.ogg","weapon_hit_21_9.ogg","weapon_hit_3.ogg","weapon_hit_4.ogg","weapon_hit_5.ogg","weapon_hit_6_0.ogg","weapon_hit_6_1.ogg","weapon_hit_6_2.ogg","weapon_hit_6_3.ogg","weapon_hit_7.ogg","weapon_hit_8.ogg","weapon_hit_9.ogg","whoosh.ogg","wrong.ogg"];
var category_list = [];

fillArrayCategory();

eventToFire.registerEvent("c2LayoutChange",
	function (args){
		if(!started){
			c2Runtime = cr_getC2Runtime();
			started = true;
			nextStep();
		}
	}
);

function update(){
	for (var i = 0; i < audioBuffer.length; i++) {
		if(audioBuffer[i].isLoadedAndDecoded()){ //audioBuffer[i].isLoaded()
			if(_verbose) console.log("sound end load & decoded:",audioBuffer[i].src);
			audioBuffer.splice(i, 1);
		}
	};

	if(audioBuffer.length == 0){
		nextStep();
	}
}

function nextStep(){
	step +=1;
	clearInterval(timerUpdate);

	if(category_list[step]){
		for (var i = category_list[step].length - 1; i >= 0; i--) {
			if(_verbose) console.log("sound start load:",category_list[step][i]);
			audioBuffer.push(c2Runtime.audioInstance.getAudioBuffer(c2Runtime.files_subfolder+category_list[step][i]));
		};

		timerUpdate = setInterval(update,100);

	}else{
		if(_verbose) console.log("all Sound loaded & decoded");
	}
}

function fillArrayCategory(){
	var firstLoad = [];
	var arrayWihtoutMusic = [];
	var musicInGame = [];
	var musicGameOver = [];
	var name;

	for (var i = 0; i < listOfAllSong.length; i++) {
		name = listOfAllSong[i].replace(/\.[a-z]+/,"");
		
		if(name == "butt_level" || name == "butt_menu" || name == "music_menu"){
			firstLoad.push(listOfAllSong[i]);
		}
		else if(name == "music_ingame"){
			musicInGame.push(listOfAllSong[i]);
		}
		//list of gameOverSong
		else if(name == "music_game_over" || name == "defeat_sound" || name == "defeat" || name == "victory_game_over" || name == "looser" || name == "gameOver_defeat" || name == "gameOver"){
			musicGameOver.push(listOfAllSong[i]);
		}
		else {
			arrayWihtoutMusic.push(listOfAllSong[i]);
		}
	};
	category_list.push(firstLoad);
	category_list.push(arrayWihtoutMusic);
	category_list.push(musicInGame);
	category_list.push(musicGameOver);
}

}())

